Package ru.bitel.bgbilling.kernel.tariff.option.common.service

# Interface TariffOptionService

    public interface TariffOptionService

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `void` | `contractTariffOptionActivate​(int contractId, int optionId, int modeId, boolean web)` | Активирование тарифной опции для договора.
  `int` | `contractTariffOptionActivateWhithSum​(int contractId, int optionId, int modeId, java.math.BigDecimal chargeSum, boolean web)` | Активирование тарифной опции для договора, с суммой расхода .
  `void` | `contractTariffOptionDeactivate​(int contractId, int contractOptionId)` | Деактивация тарифной опции.
  `void` | `contractTariffOptionDelete​(int contractId, int id, boolean customer)` |
  `java.util.List<ContractTariffOption>` | `contractTariffOptionHistory​(int contractId, java.util.Date date, boolean web)` | Получение списка тарифных опций договора, период действия которых закончился по отношении к указанной дате.
  `java.util.List<ContractTariffOption>` | `contractTariffOptionList​(int contractId, java.util.Date date)` | Получение тарифных опций период активности которых пересекается или еще не наступил с указанной датой. Т.е. активных тарифных опций.
  `java.util.List<ContractTariffOption>` | `contractTariffOptionListWeb​(int contractId, java.util.Date date, java.util.List<ContractTariffOption> contractTariffOptionList)` | Получение тарифных опций период активности которых пересекается или еще не наступил с указанной датой для web. Т.е. активных тарифных опций.
  `void` | `contractTariffOptionReactivate​(int contractId, int contractOptionId)` | Реактивация тарифной опции.
  `TariffOptionActivateMode` | `tariffOptionActivateModeGet​(int optionId, int modeId)` | Вернет режим активации.
  `java.util.List<TariffOptionActivateMode>` | `tariffOptionActivateModeList​(int optionId, java.util.Date date)` |
  `void` | `tariffOptionDelete​(int id)` | Удаление тарифной опции
  `TariffOption` | `tariffOptionGet​(int id)` | Получение тарифной опции по коду.
  `java.util.List<TariffOption>` | `tariffOptionList()` | Получение списка всех тарифных опций.
  `java.util.List<TariffOption>` | `tariffOptionListAvailable​(int contractId, java.util.Date date, java.util.List<ContractTariffOption> currentContractOptionList, boolean onlyAvailable, boolean web)` | Получение списка тарифных опций на указанную дату, c заполнением поля enable c учетом тарифов и групп договоров.
  `void` | `tariffOptionUpdate​(TariffOption tariffOption)` | Обновление тарифной опции
  `java.util.List<TariffOption>` | `tariffOptionWebList​(int contractId, java.util.Date date, java.util.List<TariffOption> fullOptionList)` | Опции, которые можно показывать в веб.

- ## Method Details

  - ### tariffOptionGet

    TariffOption tariffOptionGet​(int id) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Получение тарифной опции по коду.
    Parameters:
      `id` - код тарифной опции
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### tariffOptionList

    java.util.List<TariffOption> tariffOptionList() throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Получение списка всех тарифных опций.
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### tariffOptionWebList

    java.util.List<TariffOption> tariffOptionWebList​(int contractId, java.util.Date date, java.util.List<TariffOption> fullOptionList) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Опции, которые можно показывать в веб.
    Parameters:
      `contractId` -
      `date` -
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### tariffOptionListAvailable

    java.util.List<TariffOption> tariffOptionListAvailable​(int contractId, java.util.Date date, java.util.List<ContractTariffOption> currentContractOptionList, boolean onlyAvailable, boolean web) throws ru.bitel.bgbilling.common.BGException
    Получение списка тарифных опций на указанную дату, c заполнением поля enable c учетом тарифов и групп договоров.
    Parameters:
      `contractId` -
      `date` -
      `onlyAvailable` -
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### tariffOptionUpdate

    void tariffOptionUpdate​(TariffOption tariffOption) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Обновление тарифной опции
    Parameters:
      `tariffOption` - опция
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### tariffOptionDelete

    void tariffOptionDelete​(int id) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Удаление тарифной опции
    Parameters:
      `id` - код опции
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### tariffOptionActivateModeList

    java.util.List<TariffOptionActivateMode> tariffOptionActivateModeList​(int optionId, java.util.Date date) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### tariffOptionActivateModeGet

    TariffOptionActivateMode tariffOptionActivateModeGet​(int optionId, int modeId) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Вернет режим активации.
    Parameters:
      `modeId` - ид режима активации тарифной опции.
      `optionId` - ид тарифной опции.
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### contractTariffOptionList

    java.util.List<ContractTariffOption> contractTariffOptionList​(int contractId, java.util.Date date) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Получение тарифных опций период активности которых пересекается или еще не наступил с указанной датой.
    Т.е. активных тарифных опций.
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### contractTariffOptionListWeb

    java.util.List<ContractTariffOption> contractTariffOptionListWeb​(int contractId, java.util.Date date, java.util.List<ContractTariffOption> contractTariffOptionList) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Получение тарифных опций период активности которых пересекается или еще не наступил с указанной датой для web.
    Т.е. активных тарифных опций.
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### contractTariffOptionActivate

    void contractTariffOptionActivate​(int contractId, int optionId, int modeId, boolean web) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Активирование тарифной опции для договора.
    Parameters:
      `contractId` - договор
      `optionId` - опций
      `modeId` - режим активации опции
    Throws:
      `ru.bitel.bgbilling.common.BGException` - если активация невозможна или произошла ошибка
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### contractTariffOptionActivateWhithSum

    int contractTariffOptionActivateWhithSum​(int contractId, int optionId, int modeId, java.math.BigDecimal chargeSum, boolean web) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Активирование тарифной опции для договора, с суммой расхода .
    Parameters:
      `contractId` - договор
      `optionId` - опций
      `modeId` - режим активации опции
      `chargeSum` - сумма расхода
    Returns:
      ид расхода договора
    Throws:
      `ru.bitel.bgbilling.common.BGException` - если активация невозможна или произошла ошибка
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### contractTariffOptionDeactivate

    void contractTariffOptionDeactivate​(int contractId, int contractOptionId) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Деактивация тарифной опции.
    Parameters:
      `contractId` - договор
      `contractOptionId` - код активированной тарифной опции
    Throws:
      `ru.bitel.bgbilling.common.BGException` - если деактивация невозможна или произошла ошибка
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### contractTariffOptionReactivate

    void contractTariffOptionReactivate​(int contractId, int contractOptionId) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Реактивация тарифной опции.
    Parameters:
      `contractId` - договор
      `contractOptionId` - код деактивированной тарифной опции
    Throws:
      `ru.bitel.bgbilling.common.BGException` - если реактивация невозможна или произошла ошибка
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### contractTariffOptionHistory

    java.util.List<ContractTariffOption> contractTariffOptionHistory​(int contractId, java.util.Date date, boolean web) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Получение списка тарифных опций договора, период действия которых закончился по отношении к указанной дате.
    Parameters:
      `contractId` - договор
      `date` - дата
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### contractTariffOptionDelete

    void contractTariffOptionDelete​(int contractId, int id, boolean customer) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`